package com.qmth.cqb.paper.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import com.qmth.cqb.paper.model.CourseProperty;
/**
 * @describle 课程属性repo
 * @author weiwenhai
 * @date   2017.11.2
 */
public interface CoursePropertyRepo extends JpaRepository<CourseProperty, Long>,QueryByExampleExecutor<CourseProperty>,JpaSpecificationExecutor<CourseProperty>{
	
	//查询所有课程属性
	List<CourseProperty> findByOrgId(Long orgId);
	
	//根据属性名查询
	CourseProperty findByNameAndOrgId(String name, Long orgId);
	
	//根据课程id查询
	List<CourseProperty> findByCourseId(Long courseId);

}
