package com.qmth.cqb.paper.dao;

import cn.com.qmth.examcloud.common.dto.question.enums.QuesStructType;
import com.qmth.cqb.paper.model.Paper;
import com.qmth.cqb.paper.model.PaperDetail;
import org.springframework.data.mongodb.repository.MongoRepository;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import com.qmth.cqb.paper.model.PaperDetailUnit;
import com.qmth.cqb.question.model.Question;

import java.util.List;


public interface PaperDetailUnitRepo extends MongoRepository<PaperDetailUnit, String>,QueryByExampleExecutor<PaperDetailUnit> {
    List<PaperDetailUnit> findByPaperDetailOrderByNumber(PaperDetail paperDetail);
    List<PaperDetailUnit> findByPaperOrderByNumber(Paper paper);
    List<PaperDetailUnit> findByQuestion(Question question);
    List<PaperDetailUnit> findByQuestionIn(List<Question> questionList);
    PaperDetailUnit findById(String id);
    List<PaperDetailUnit> findByQuestionType(QuesStructType quesType);
    Long countByPaperDetail(PaperDetail paperDetail);
    /**
     * 查询大题下的小题
     * 按number降序排列，取第一个，也就是number最大那个
     * @param paperDetail
     * @return
     */
    PaperDetailUnit findTopByPaperDetailOrderByNumberDesc(PaperDetail paperDetail);
    /**
     * 查询大题下的小题
     * 按number升序排列，取第一个，也就是number最小那个
     * @param paperDetail
     * @return
     */
    PaperDetailUnit findTopByPaperDetailOrderByNumberAsc(PaperDetail paperDetail);
}
