package com.qmth.cqb.paper.model;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;

import com.qmth.cqb.utils.CommonUtils;

/**
 * 试卷结构 Created by songyue on 16/12/28.
 */

public class PaperStruct implements Serializable {

    private static final long serialVersionUID = 6380530617488717881L;

    @Id
    private String id;

    @Indexed(unique = true)
    private String name;// 试卷结构名称

    private Double totalScore;// 总分

    private Integer detailCount;// 大题数量

    private Integer detailUnitCount;//小题数量

    private Map params;

    private List<PaperDetailStruct> paperDetailStructs;// 大题

    private String creator;// 创建人id

    private String createTime;// 创建时间

    private String orgId;// 机构ID

    private String courseNo;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Double getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(Double totalScore) {
        this.totalScore = totalScore;
    }

    public Integer getDetailCount() {
        return detailCount;
    }

    public void setDetailCount(Integer detailCount) {
        this.detailCount = detailCount;
    }

    public Map getParams() {
        return params;
    }

    public void setParams(Map params) {
        this.params = params;
    }

    public List<PaperDetailStruct> getPaperDetailStructs() {
        return paperDetailStructs;
    }

    public void setPaperDetailStructs(List<PaperDetailStruct> paperDetailStructs) {
        this.paperDetailStructs = paperDetailStructs;
    }

    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public PaperStruct() {
        this.createTime = CommonUtils.getCurDateTime();
    }

    public String getOrgId() {
        return orgId;
    }

    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }

    public String getCourseNo() {
        return courseNo;
    }

    public void setCourseNo(String courseNo) {
        this.courseNo = courseNo;
    }

    public Integer getDetailUnitCount() {
        return detailUnitCount;
    }

    public void setDetailUnitCount(Integer detailUnitCount) {
        this.detailUnitCount = detailUnitCount;
    }
}
