package com.qmth.cqb.paper.service;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import com.qmth.cqb.paper.dto.CoursePropertyDto;
import com.qmth.cqb.paper.model.CourseProperty;

/**
 * @describle 课程属性 coursePropertyService
 * @author weiwenhai
 * @date   2017.11.2
 */
public interface CoursePropertyService {

	/**
	 * 查询所有课程属性
	 * @param orgId
	 * @return
	 */
	public List<CourseProperty> findAllByOrgId(Long orgId);
	
	/**
	 * 查询所有课程属性带分页
	 * @param coursePropertyDto
	 * @param pageable
	 * @return
	 */
	public Page<CourseProperty> findAllByOrg(CoursePropertyDto coursePropertyDto, Pageable pageable);
	
	/**
	 * 保存课程属性
	 * @param coursePropertyDto
	 */
	public void saveCourseProperty(CoursePropertyDto coursePropertyDto) throws Exception;
	
	/**
	 * 启用
	 * @param id
	 * @param orgId
	 */
	public void openCourseProperty(Long id, Long orgId);
	
	/**
	 * 禁用
	 * @param id
	 * @param orgId
	 */
	public void closeCourseProperty(Long id ,Long orgId);
	
	/**
	 * 根据课程id查询所有课程属性
	 * @param courseId
	 * @return
	 */
	public List<CourseProperty> findAllByCourseId(Long courseId);
}
